/**
 * Autogenerated by Thrift
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 */
package com.evernote.edam.userstore;

import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.EnumMap;
import java.util.Set;
import java.util.HashSet;
import java.util.EnumSet;
import java.util.Collections;
import com.evernote.edam.util.BitSet;
import java.util.Arrays;

import org.apache.thrift.*;
import org.apache.thrift.meta_data.*;
import org.apache.thrift.protocol.*;

/**
 *  When an authentication (or re-authentication) is performed, this structure
 *  provides the result to the client.
 * <dl>
 *  <dt>currentTime:</dt>
 *    <dd>
 *    The server-side date and time when this result was
 *    generated.
 *    </dd>
 *  <dt>authenticationToken:</dt>
 *    <dd>
 *    Holds an opaque, ASCII-encoded token that can be
 *    used by the client to perform actions on a NoteStore.
 *    </dd>
 *  <dt>expiration:</dt>
 *    <dd>
 *    Holds the server-side date and time when the
 *    authentication token will expire.
 *    This time can be compared to "currentTime" to produce an expiration
 *    time that can be reconciled with the client's local clock.
 *    </dd>
 *  <dt>user:</dt>
 *    <dd>
 *    Holds the information about the account which was
 *    authenticated if this was a full authentication.  May be absent if this
 *    particular authentication did not require user information.
 *    </dd>
 *  <dt>publicUserInfo:</dt>
 *    <dd>
 *    If this authentication result was achieved without full permissions to
 *    access the full User structure, this field may be set to give back
 *    a more limited public set of data.
 *    </dd>
 *  </dl>
 */
public class AuthenticationResult implements TBase<AuthenticationResult._Fields>, java.io.Serializable, Cloneable, Comparable<AuthenticationResult> {
  private static final TStruct STRUCT_DESC = new TStruct("AuthenticationResult");

  private static final TField CURRENT_TIME_FIELD_DESC = new TField("currentTime", TType.I64, (short)1);
  private static final TField AUTHENTICATION_TOKEN_FIELD_DESC = new TField("authenticationToken", TType.STRING, (short)2);
  private static final TField EXPIRATION_FIELD_DESC = new TField("expiration", TType.I64, (short)3);
  private static final TField USER_FIELD_DESC = new TField("user", TType.STRUCT, (short)4);
  private static final TField PUBLIC_USER_INFO_FIELD_DESC = new TField("publicUserInfo", TType.STRUCT, (short)5);

  private long currentTime;
  private String authenticationToken;
  private long expiration;
  private com.evernote.edam.type.User user;
  private PublicUserInfo publicUserInfo;

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements TFieldIdEnum {
    CURRENT_TIME((short)1, "currentTime"),
    AUTHENTICATION_TOKEN((short)2, "authenticationToken"),
    EXPIRATION((short)3, "expiration"),
    USER((short)4, "user"),
    PUBLIC_USER_INFO((short)5, "publicUserInfo");

    private static final Map<Integer, _Fields> byId = new HashMap<Integer, _Fields>();
    private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

    static {
      for (_Fields field : EnumSet.allOf(_Fields.class)) {
        byId.put((int)field._thriftId, field);
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    public static _Fields findByThriftId(int fieldId) {
      return byId.get(fieldId);
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    public static _Fields findByName(String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final String _fieldName;

    _Fields(short thriftId, String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments
  private static final int __CURRENTTIME_ISSET_ID = 0;
  private static final int __EXPIRATION_ISSET_ID = 1;
  private BitSet __isset_bit_vector = new BitSet(2);

  public static final Map<_Fields, FieldMetaData> metaDataMap = Collections.unmodifiableMap(new EnumMap<_Fields, FieldMetaData>(_Fields.class) {{
    put(_Fields.CURRENT_TIME, new FieldMetaData("currentTime", TFieldRequirementType.REQUIRED, 
        new FieldValueMetaData(TType.I64)));
    put(_Fields.AUTHENTICATION_TOKEN, new FieldMetaData("authenticationToken", TFieldRequirementType.REQUIRED, 
        new FieldValueMetaData(TType.STRING)));
    put(_Fields.EXPIRATION, new FieldMetaData("expiration", TFieldRequirementType.REQUIRED, 
        new FieldValueMetaData(TType.I64)));
    put(_Fields.USER, new FieldMetaData("user", TFieldRequirementType.OPTIONAL, 
        new StructMetaData(TType.STRUCT, com.evernote.edam.type.User.class)));
    put(_Fields.PUBLIC_USER_INFO, new FieldMetaData("publicUserInfo", TFieldRequirementType.OPTIONAL, 
        new StructMetaData(TType.STRUCT, PublicUserInfo.class)));
  }});

  static {
    FieldMetaData.addStructMetaDataMap(AuthenticationResult.class, metaDataMap);
  }

  public AuthenticationResult() {
  }

  public AuthenticationResult(
    long currentTime,
    String authenticationToken,
    long expiration)
  {
    this();
    this.currentTime = currentTime;
    setCurrentTimeIsSet(true);
    this.authenticationToken = authenticationToken;
    this.expiration = expiration;
    setExpirationIsSet(true);
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public AuthenticationResult(AuthenticationResult other) {
    __isset_bit_vector.clear();
    __isset_bit_vector.or(other.__isset_bit_vector);
    this.currentTime = other.currentTime;
    if (other.isSetAuthenticationToken()) {
      this.authenticationToken = other.authenticationToken;
    }
    this.expiration = other.expiration;
    if (other.isSetUser()) {
      this.user = new com.evernote.edam.type.User(other.user);
    }
    if (other.isSetPublicUserInfo()) {
      this.publicUserInfo = new PublicUserInfo(other.publicUserInfo);
    }
  }

  public AuthenticationResult deepCopy() {
    return new AuthenticationResult(this);
  }

  @Deprecated
  public AuthenticationResult clone() {
    return new AuthenticationResult(this);
  }

  public long getCurrentTime() {
    return this.currentTime;
  }

  public void setCurrentTime(long currentTime) {
    this.currentTime = currentTime;
    setCurrentTimeIsSet(true);
  }

  public void unsetCurrentTime() {
    __isset_bit_vector.clear(__CURRENTTIME_ISSET_ID);
  }

  /** Returns true if field currentTime is set (has been asigned a value) and false otherwise */
  public boolean isSetCurrentTime() {
    return __isset_bit_vector.get(__CURRENTTIME_ISSET_ID);
  }

  public void setCurrentTimeIsSet(boolean value) {
    __isset_bit_vector.set(__CURRENTTIME_ISSET_ID, value);
  }

  public String getAuthenticationToken() {
    return this.authenticationToken;
  }

  public void setAuthenticationToken(String authenticationToken) {
    this.authenticationToken = authenticationToken;
  }

  public void unsetAuthenticationToken() {
    this.authenticationToken = null;
  }

  /** Returns true if field authenticationToken is set (has been asigned a value) and false otherwise */
  public boolean isSetAuthenticationToken() {
    return this.authenticationToken != null;
  }

  public void setAuthenticationTokenIsSet(boolean value) {
    if (!value) {
      this.authenticationToken = null;
    }
  }

  public long getExpiration() {
    return this.expiration;
  }

  public void setExpiration(long expiration) {
    this.expiration = expiration;
    setExpirationIsSet(true);
  }

  public void unsetExpiration() {
    __isset_bit_vector.clear(__EXPIRATION_ISSET_ID);
  }

  /** Returns true if field expiration is set (has been asigned a value) and false otherwise */
  public boolean isSetExpiration() {
    return __isset_bit_vector.get(__EXPIRATION_ISSET_ID);
  }

  public void setExpirationIsSet(boolean value) {
    __isset_bit_vector.set(__EXPIRATION_ISSET_ID, value);
  }

  public com.evernote.edam.type.User getUser() {
    return this.user;
  }

  public void setUser(com.evernote.edam.type.User user) {
    this.user = user;
  }

  public void unsetUser() {
    this.user = null;
  }

  /** Returns true if field user is set (has been asigned a value) and false otherwise */
  public boolean isSetUser() {
    return this.user != null;
  }

  public void setUserIsSet(boolean value) {
    if (!value) {
      this.user = null;
    }
  }

  public PublicUserInfo getPublicUserInfo() {
    return this.publicUserInfo;
  }

  public void setPublicUserInfo(PublicUserInfo publicUserInfo) {
    this.publicUserInfo = publicUserInfo;
  }

  public void unsetPublicUserInfo() {
    this.publicUserInfo = null;
  }

  /** Returns true if field publicUserInfo is set (has been asigned a value) and false otherwise */
  public boolean isSetPublicUserInfo() {
    return this.publicUserInfo != null;
  }

  public void setPublicUserInfoIsSet(boolean value) {
    if (!value) {
      this.publicUserInfo = null;
    }
  }

  public void setFieldValue(_Fields field, Object value) {
    switch (field) {
    case CURRENT_TIME:
      if (value == null) {
        unsetCurrentTime();
      } else {
        setCurrentTime((Long)value);
      }
      break;

    case AUTHENTICATION_TOKEN:
      if (value == null) {
        unsetAuthenticationToken();
      } else {
        setAuthenticationToken((String)value);
      }
      break;

    case EXPIRATION:
      if (value == null) {
        unsetExpiration();
      } else {
        setExpiration((Long)value);
      }
      break;

    case USER:
      if (value == null) {
        unsetUser();
      } else {
        setUser((com.evernote.edam.type.User)value);
      }
      break;

    case PUBLIC_USER_INFO:
      if (value == null) {
        unsetPublicUserInfo();
      } else {
        setPublicUserInfo((PublicUserInfo)value);
      }
      break;

    }
  }

  public void setFieldValue(int fieldID, Object value) {
    setFieldValue(_Fields.findByThriftIdOrThrow(fieldID), value);
  }

  public Object getFieldValue(_Fields field) {
    switch (field) {
    case CURRENT_TIME:
      return new Long(getCurrentTime());

    case AUTHENTICATION_TOKEN:
      return getAuthenticationToken();

    case EXPIRATION:
      return new Long(getExpiration());

    case USER:
      return getUser();

    case PUBLIC_USER_INFO:
      return getPublicUserInfo();

    }
    throw new IllegalStateException();
  }

  public Object getFieldValue(int fieldId) {
    return getFieldValue(_Fields.findByThriftIdOrThrow(fieldId));
  }

  /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
  public boolean isSet(_Fields field) {
    switch (field) {
    case CURRENT_TIME:
      return isSetCurrentTime();
    case AUTHENTICATION_TOKEN:
      return isSetAuthenticationToken();
    case EXPIRATION:
      return isSetExpiration();
    case USER:
      return isSetUser();
    case PUBLIC_USER_INFO:
      return isSetPublicUserInfo();
    }
    throw new IllegalStateException();
  }

  public boolean isSet(int fieldID) {
    return isSet(_Fields.findByThriftIdOrThrow(fieldID));
  }

  public boolean equals(Object that) {
    if (that == null)
      return false;
    if (that instanceof AuthenticationResult)
      return this.equals((AuthenticationResult)that);
    return false;
  }

  public boolean equals(AuthenticationResult that) {
    if (that == null)
      return false;

    boolean this_present_currentTime = true;
    boolean that_present_currentTime = true;
    if (this_present_currentTime || that_present_currentTime) {
      if (!(this_present_currentTime && that_present_currentTime))
        return false;
      if (this.currentTime != that.currentTime)
        return false;
    }

    boolean this_present_authenticationToken = true && this.isSetAuthenticationToken();
    boolean that_present_authenticationToken = true && that.isSetAuthenticationToken();
    if (this_present_authenticationToken || that_present_authenticationToken) {
      if (!(this_present_authenticationToken && that_present_authenticationToken))
        return false;
      if (!this.authenticationToken.equals(that.authenticationToken))
        return false;
    }

    boolean this_present_expiration = true;
    boolean that_present_expiration = true;
    if (this_present_expiration || that_present_expiration) {
      if (!(this_present_expiration && that_present_expiration))
        return false;
      if (this.expiration != that.expiration)
        return false;
    }

    boolean this_present_user = true && this.isSetUser();
    boolean that_present_user = true && that.isSetUser();
    if (this_present_user || that_present_user) {
      if (!(this_present_user && that_present_user))
        return false;
      if (!this.user.equals(that.user))
        return false;
    }

    boolean this_present_publicUserInfo = true && this.isSetPublicUserInfo();
    boolean that_present_publicUserInfo = true && that.isSetPublicUserInfo();
    if (this_present_publicUserInfo || that_present_publicUserInfo) {
      if (!(this_present_publicUserInfo && that_present_publicUserInfo))
        return false;
      if (!this.publicUserInfo.equals(that.publicUserInfo))
        return false;
    }

    return true;
  }

  public int hashCode() {
    return 0;
  }

  public int compareTo(AuthenticationResult other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;
    AuthenticationResult typedOther = (AuthenticationResult)other;

    lastComparison = Boolean.valueOf(isSetCurrentTime()).compareTo(isSetCurrentTime());
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = TBaseHelper.compareTo(currentTime, typedOther.currentTime);
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = Boolean.valueOf(isSetAuthenticationToken()).compareTo(isSetAuthenticationToken());
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = TBaseHelper.compareTo(authenticationToken, typedOther.authenticationToken);
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = Boolean.valueOf(isSetExpiration()).compareTo(isSetExpiration());
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = TBaseHelper.compareTo(expiration, typedOther.expiration);
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = Boolean.valueOf(isSetUser()).compareTo(isSetUser());
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = TBaseHelper.compareTo(user, typedOther.user);
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = Boolean.valueOf(isSetPublicUserInfo()).compareTo(isSetPublicUserInfo());
    if (lastComparison != 0) {
      return lastComparison;
    }
    lastComparison = TBaseHelper.compareTo(publicUserInfo, typedOther.publicUserInfo);
    if (lastComparison != 0) {
      return lastComparison;
    }
    return 0;
  }

  public void read(TProtocol iprot) throws TException {
    TField field;
    iprot.readStructBegin();
    while (true)
    {
      field = iprot.readFieldBegin();
      if (field.type == TType.STOP) { 
        break;
      }
      _Fields fieldId = _Fields.findByThriftId(field.id);
      if (fieldId == null) {
        TProtocolUtil.skip(iprot, field.type);
      } else {
        switch (fieldId) {
          case CURRENT_TIME:
            if (field.type == TType.I64) {
              this.currentTime = iprot.readI64();
              setCurrentTimeIsSet(true);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case AUTHENTICATION_TOKEN:
            if (field.type == TType.STRING) {
              this.authenticationToken = iprot.readString();
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case EXPIRATION:
            if (field.type == TType.I64) {
              this.expiration = iprot.readI64();
              setExpirationIsSet(true);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case USER:
            if (field.type == TType.STRUCT) {
              this.user = new com.evernote.edam.type.User();
              this.user.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
          case PUBLIC_USER_INFO:
            if (field.type == TType.STRUCT) {
              this.publicUserInfo = new PublicUserInfo();
              this.publicUserInfo.read(iprot);
            } else { 
              TProtocolUtil.skip(iprot, field.type);
            }
            break;
        }
        iprot.readFieldEnd();
      }
    }
    iprot.readStructEnd();
    validate();
  }

  public void write(TProtocol oprot) throws TException {
    validate();

    oprot.writeStructBegin(STRUCT_DESC);
    oprot.writeFieldBegin(CURRENT_TIME_FIELD_DESC);
    oprot.writeI64(this.currentTime);
    oprot.writeFieldEnd();
    if (this.authenticationToken != null) {
      oprot.writeFieldBegin(AUTHENTICATION_TOKEN_FIELD_DESC);
      oprot.writeString(this.authenticationToken);
      oprot.writeFieldEnd();
    }
    oprot.writeFieldBegin(EXPIRATION_FIELD_DESC);
    oprot.writeI64(this.expiration);
    oprot.writeFieldEnd();
    if (this.user != null) {
      if (isSetUser()) {
        oprot.writeFieldBegin(USER_FIELD_DESC);
        this.user.write(oprot);
        oprot.writeFieldEnd();
      }
    }
    if (this.publicUserInfo != null) {
      if (isSetPublicUserInfo()) {
        oprot.writeFieldBegin(PUBLIC_USER_INFO_FIELD_DESC);
        this.publicUserInfo.write(oprot);
        oprot.writeFieldEnd();
      }
    }
    oprot.writeFieldStop();
    oprot.writeStructEnd();
  }

  public String toString() {
    StringBuilder sb = new StringBuilder("AuthenticationResult(");
    boolean first = true;

    sb.append("currentTime:");
    sb.append(this.currentTime);
    first = false;
    if (!first) sb.append(", ");
    sb.append("authenticationToken:");
    if (this.authenticationToken == null) {
      sb.append("null");
    } else {
      sb.append(this.authenticationToken);
    }
    first = false;
    if (!first) sb.append(", ");
    sb.append("expiration:");
    sb.append(this.expiration);
    first = false;
    if (isSetUser()) {
      if (!first) sb.append(", ");
      sb.append("user:");
      if (this.user == null) {
        sb.append("null");
      } else {
        sb.append(this.user);
      }
      first = false;
    }
    if (isSetPublicUserInfo()) {
      if (!first) sb.append(", ");
      sb.append("publicUserInfo:");
      if (this.publicUserInfo == null) {
        sb.append("null");
      } else {
        sb.append(this.publicUserInfo);
      }
      first = false;
    }
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws TException {
    // check for required fields
    if (!isSetCurrentTime()) {
      throw new TProtocolException("Required field 'currentTime' is unset! Struct:" + toString());
    }

    if (!isSetAuthenticationToken()) {
      throw new TProtocolException("Required field 'authenticationToken' is unset! Struct:" + toString());
    }

    if (!isSetExpiration()) {
      throw new TProtocolException("Required field 'expiration' is unset! Struct:" + toString());
    }

  }

}

